#!/bin/bash

PEER="hub3"
ARBASE="/home/medsrv/var/archive/"
DEBUG="true"

[ -z "$1" ] && echo -e "\n\tMissing Argument: Study List file.  Usage: $0 <studylistfile>\n" && exit -1


for s in `cat $1`
do
   echo -e "\n$s"
   ADIR=`$HOME/component/tools/q_archiveloc.sh $s | sed -e "s!$ARBASE!!"`
   if [ ! -z "$ADIR" ] ; then
      echo -e "\tLocal Dir: $ADIR"
      peerADIR=`ssh $PEER $HOME/component/tools/q_archiveloc.sh $s | sed -e "s!$ARBASE!!"`
      if [ -z "$peerADIR" ] ; then
        echo -e "\tPeer's Archive Table has no entry for this study."
        peerADIR="gmas1/$ADIR"
      fi
      peerWC=`ssh $PEER ls var/archive/$peerADIR | wc -l`
      origADIR=`echo $peerADIR | sed -e "s!gmas1/!!"`
      localWC=`ls ~/var/archive/$origADIR | wc -l`
      if [ "$DEBUG" = "true" ] ; then
        echo -e "\t$PEER adir: $peerADIR"
        echo -e "\tObjects on Peer: $peerWC"
        echo -e "\tLocal adir: $origADIR"
        echo -e "\tObjects on local: $localWC"
      fi
      if [ "$peerWC" = "$localWC" ] ; then
         echo "$s is Good"
         echo "$s" >> $1.alsomoved
      else
         echo "$s is REALLY FAILED"
         echo "$s" >> $1.reallyfailed
         echo -e "\t Copying files..."
         echo "cp /home/medsrv/var/archive/$ADIR/* /home/medsrv/var/archive/gmas1/$ADIR/"
         cp /home/medsrv/var/archive/$ADIR/* /home/medsrv/var/archive/gmas1/$ADIR/
         RES=$?
         echo "File Copy return code: $RES" 
      fi
   else
      echo -e "\tADIR: $ADIR"
      WC=`ls var/archive/$ADIR | wc -l`
      echo -e "\tObjects on local: $WC"
      echo "$s" >> $1.reallyfailed
   fi

done
