#!/bin/bash
#
# Usage: VerifySTY.sh STYIUID
#
#


[ -z "$1" ] && echo -e "\n\n\tERROR: STYIUID expected" && exit

CLEANUPFILE="Cleanup.stys"

HASHDIR=`$HOME/component/utils/bin/getHashDirectory -i $1`
ARCHDIR=`/home/image/tools/q_archiveloc.sh $1`

if [ ! -d $HOME/data/dicom.hashed/$HASHDIR ] ; then
	echo -e "\nERROR: $1 has no local dir: $HOME/data/dicom.hashed/$HASHDIR"
        echo $1 >> $CLEANUPFILE
        exit
fi

if [ "$ARCHDIR" = "/home/medsrv/var/archive/" ] ; then
	echo -e "\nERROR: $1 Archive directory not set"
        exit
fi

LocalObjCnt=`ls $HOME/data/dicom.hashed/$HASHDIR | wc -l`
ArchObjCnt=`ls $ARCHDIR | wc -l`


echo -e "\n$1: $LocalObjCnt local objects in $HOME/data/dicom.hashed/$HASHDIR"
echo -e "$1: $ArchObjCnt Archive objects in $ARCHDIR"

if [ $LocalObjCnt -lt $ArchObjCnt ] ; then
	echo -e " Fewer objects on local than in the archive"
elif [ $ArchObjCnt -lt $LocalObjCnt ] ; then
	echo -e " Fewer objects in the archive than on local"
        rsync --exclude ".info" --exclude ".tmp" -va $HOME/data/dicom.hashed/$HASHDIR $ARCHDIR/
else
	echo -e "Same number of objects in both places"
        echo $1 >> $CLEANUPFILE
fi

echo -e "\n\n"
