#!/bin/sh
#
# Component: util
#
# Description:
#  Compresses the whole Archive.
#
# Usage:
#   compressArchive.sh 
#
# Last Updated     : $Author: zsurmi $
# Update Date Time : $Date: 2015/04/14 08:12:57 $
# RCS File Name    : $RCSfile: compressStudyDirectory.sh,v $
# RCS Revision     : $Revision: 1.1 $
# Locked by        : $Locker:  $
# Symbolic name    : $Name:  $
# State            : $State: Exp $
#

if [ -z "$1" ]; then
    echo;echo;echo
    echo "$0 <repository_dir> [ nice ]"
    echo
    echo "If the optional "nice" parameter is given, only compress when the"
    echo "server is not busy processing medsrv tasks"
    echo;echo;echo
    exit 1
fi

CompressionMode="JPEGLossless"
MinLosslessRatio="1.5"
STY="$1"
myrepository_dir=`/home/medsrv/component/repositoryhandler/scripts/locateStudy.sh -d $STY`    

if [ -n "$2" ]; then
    if [ -e ~/component/tools/scripttools.shi ]; then
        benice="yes"
    else
        echo
        echo "ERROR: The nice option requires ~/component/tools/scripttools.shi,"
        echo "which does not appear to exist on this server."
        echo
        exit 0
    fi
fi

if [ -n "$benice" ]; then
    . ~/component/tools/scripttools.shi
else
    . $HOME/etc/setenv.sh
fi

#if [ ! -e $ARCHIVE_VAR/archive.cfg ] ; then
#	echo -e "\n\n\n"
#	echo -e "\tConfiguration file  $ARCHIVE_VAR/archive.cfg missing and is needed by compressObject. It is needed and it needs"
#	echo -e "to have the lines: CompressionMode and MinLosslessRatio set it it.  NOTE: it can read Archive=no, but it must be"
#	echo -e "present and have those configuration settings present, or compressObject.sh will not actually compress any objs."
#	echo -e "\n\n\n"
#	exit 1
#fi


isFolder()
{
    currentDirectory=`pwd`
    cd "$1" 2>/dev/null
    [ $? != 0 ] && return 1
    cd -
    return 0
}

compressDir_()
{
    if [ -f $1 ] ; then
        if [ -n "$benice" ]; then
            niceme && break
        fi
	#echo "$UTILS_HOME/bin/compressObject.sh -v -i $1 -t \"..$tabulation\" "
	#$UTILS_HOME/bin/compressObject.sh -i $1 -v -t "..$tabulation" 
	echo "$HOME/compressObject.sh -v -i $1 -t \"..$tabulation\" "
	$HOME/compressObject.sh -i $1 -v -t "..$tabulation" 
	return $?
    fi
    isFolder $1
    [ $? != 0 ] && return 0
    cd "$1"
    echo "${tabulation}processing $1"
    tabulation="..$tabulation"
    for i in `ls 2>/dev/null` ; do
        if [ -n "$benice" ] ; then
            niceme 
            isstopped && break
        fi
	compressDir_ $i
    done
    tabulation="${tabulation:2}"
    cd ..
}

# Set this to whatever repository_dir you want to compress
RepositoryDir="$myrepository_dir"

startPoint=`pwd`

if [ ! -d "$RepositoryDir" ] ; then
    echo "The Repository Directory, $RepositoryDir, doesn't exist."
    exit 1
fi


startDir=`pwd`

tabulation=".."

echo "compressing $RepositoryDir"

echo "compressDir_ \"$RepositoryDir\""
compressDir_ "$RepositoryDir"
cd "$startDir"

echo "finished."
