#!/bin/bash

archivepartitions="$1"
inplacereponame="$2" # e.g. hub1data*

# if we are migrating in place (to repositories on the same partition as the archive)
# then we should count everything but the data repositories

if [ -n "${inplacereponame}" ]; then
	alldirs=$(for p in $archivepartitions; do find ~/var/archive/$p -mindepth 1 -maxdepth 1 -type d ! -name "${inplacereponame}"; done)

	for p in $archivepartitions; do
	    echo
	    echo "Used space on $p in MB at date: $(date)"
	    du -h -s -m --total $(find ~/var/archive/$p -mindepth 1 -maxdepth 1 -type d ! -name "${inplacereponame}")   
	done

	if [ ${#archivepartitions[@]} -gt 1 ]; then
	    echo
	    du -h -s -m --total $alldirs
	    echo "Used space on all archive directories in MB at date: $(date)"
	fi
else

	echo "Used space in MB at date: $(date)"
	df -B 1M
fi


