#!/bin/bash
#
#  Looks for and corrects hashed dirs which do not have thier
#  cooresponding dicom links.
#  
#

. $HOME/etc/setenv.sh

DicomFile="hashed.dicom.dirs"

if [ ! -e "$DicomFile" ] ; then
   echo "Hash directory file, $DicomFile, does not exist."
   echo "Creating it now.  Please be patient as this may take a long time (1hr)."
   echo "find $HASHED_DICOM_DATA -name \"[0-9]*.[0-9]*\" > $DicomFile"
   find $HASHED_DICOM_DATA -name "[0-9]*.[0-9]*" > $DicomFile
fi


while read hashdir
do
   STUDY=`basename $hashdir`
   #echo $STUDY
   if [ ! -e $HOME/data/dicom/$STUDY ] ; then
      echo "Creating missing link"
      # Get Hash
      hdir=`$UTILS_HOME/bin/getHashDirectory -i $STUDY`
      # Build link target
      linktarget="$HASHED_DICOM_DATA/$hdir"
      # Tell the user exactly what we are about to do
      echo "ln -s $linktarget $DICOM_DATA/$STUDY"
      # Do it
      ln -s $linktarget $DICOM_DATA/$STUDY
   fi
done < $DicomFile
