#!/bin/bash
#
#  $mountpoint - archive mount point to make room on, i.e. a2
#  $numtodo - number of studies to move, i.e. 1000
#  $destinationmountpoint - destination mount point, i.e. a4

mountpoint=$1
numtodo=$2
destinationmountpoint=$3

function usage {
  echo -e "\n\n$0 MountPoint NumberOfStys Destination"
  echo -e "\nWHERE:\n+ MountPoint is the archive mount point which needs more room, i.e. a2"
  echo    "+ NumberOfStys is the Number of studies to move to make space, i.e. 1000"
  echo    "+ Destination is the Destination MountPoint to where studies are to be  moved, i.e. a4"
  echo -e "\n\n"
}

if [ -z "$mountpoint" ] ; then
  usage
  exit 120
fi

if [ -z "$numtodo" ] ; then
  usage
  exit 120
fi

if [ -z "$destinationmountpoint" ] ; then
  usage
  exit 120
fi

ARCHBASE="$HOME/var/archive"

DB="$HOME/component/mysql/bin/mysql -N imagemedical"


count=0
STYS=`echo "select STYIUID from Archive where ARCHDIR like '$mountpoint%' limit $numtodo" | $DB`

   for s in $STYS
   do
      echo -e "\n\n---------------------------------------------------------"
      ARCHDIR=`echo "select ARCHDIR from Archive where STYIUID = '$s'" | $DB`
      if [[ $count -eq $numtodo ]] ; then
         break
      fi
      NEWARCHDIR=`echo $ARCHDIR | sed -e "s!$mountpoint!$destinationmountpoint!"`
      echo -e "\t$count:\t$s\t$ARCHDIR\t$NEWARCHDIR"
      if [ ! -e $ARCHBASE/$NEWARCHDIR/ ] ; then
         mkdir -p $ARCHBASE/$NEWARCHDIR
         RES=$?
         if [ $RES -ne 0 ] ; then
            echo "mkdir -p $ARCHBASE/$NEWARCHDIR returned $RES, exiting"
            continue
         fi
      fi
      rsync -va $ARCHBASE/$ARCHDIR/$s $ARCHBASE/$NEWARCHDIR/
      RES=$?
      if [ $RES -eq 0 ] ; then
         echo "update Archive set ARCHDIR = '$NEWARCHDIR' where STYIUID = '$s'" | $DB
         echo "Updating DB, setting ARCHDIR = $NEWARCHDIR where STYIUID = $s"
         if [ ! -z "$s" ] ; then
            rm -rf $ARCHBASE/$ARCHDIR/$s/
            echo "Removing old archive directory: $ARCHBASE/$ARCHDIR/$s/"
         fi
      else
         echo "rsync returned $RES.  Not updating DB"
         continue
      fi
      count=$((count+1))
      [ -f /tmp/stopmk ] && { echo "/tmp/stopmk found, exiting" ; rm -f /tmp/stopmk ; break ; }
   done | tee /home/medsrv/$0.$$.out

