#! /bin/bash

cd /home/medsrv

. ~/etc/setenv.sh

PBv521=$(head -1 ~/etc/component.ls|awk '{print $4}'|egrep ^5\.2\.1-)

is521() {
    # Returns 0 if the server is version 5.2.1
    [ -z "$PBv521" ] && return 1 || return 0
}

hasm6() {
    # returns 0 if a server has 5.2.1 medley 6
    [ -e /home/medsrv/patch/patch.521.medley-6.tar.gz ] && return 0 || return 1
}

echo -n  "Checking version (must be 5.2.1).. "
if is521; then
    echo "OK"
    echo -n "Checking patch level (must have 5.2.1 medley-6) .. "
    if hasm6; then
        echo "OK"
        [ ! -d ~/patch/patch.53 ] && mkdir ~/patch/patch.53
        echo "Downloading 5.3 patches..."
        echo "Enter helen's password at the prompt"
        rsync -va -e ssh root@68.208.149.227:/home/medsrv/releases/patch.53 /home/medsrv/patch/
        echo "chmoding component writeable.."
        chmod -R a+w component
        for p in $(ls -1tr patch/patch.53/); do
            echo -n "Applying $p:"
            tar -zxf patch/patch.53/$p
            if [ $? -eq 0 ]; then
                cp -a patch/patch.53/$p patch/
                [ -z "$applied" ] && applied=$p || applied="$applied $p"
                echo "OK"
            else
                echo "ERROR"
                err=1
                break
            fi
        done
        for p in $applied; do
            echo "Applied $p"
        done
        echo
        [ -n "$err" ] && echo "WARNING: some patches were not applied!"
        echo
    else
        echo "Missing patch m6, can't upgrade"
    fi
else
    echo "Not 5.2.1, can't upgrade to 5.3"
fi

