#!/bin/bash
#THIS IS FOR ENGINEERING AND MANUFACTURING USE ONLY!

now=$(date +"%m.%d.%Y")
cleanup_name=".$now"
tar_name="opensslbackup.$now.tgz"
ssl_conf_name="ssl.conf.$now.bak"

echo "Downloading eRAD SSL wildcard from server.."
echo -e "Please enter the gold server password at the prompt\n"
rsync -va -e ssh root@12.218.122.39:/home/medsrv/ERAD_SSL /home/medsrv --progress
if [ $? -ne 0 ]; then
        echo "rsync returned with error $?"
        echo "Aborting..."
        exit 1
    fi
    echo -e "Download of eRAD SSL wildcard successful\n"

echo "Backing up existing certificate"
tar -czvf /home/medsrv/$tar_name /home/medsrv/var/openssl
echo -e "Backup saved to /home/medsrv/$tar_name\n"

echo -e "Replacing private key\n"
cp -va /home/medsrv/ERAD_SSL/eradSSLkey.key /home/medsrv/var/openssl/privkey.pem

echo -e "Replacing certificate default.pem\n"
cp -va /home/medsrv/ERAD_SSL/4b758e529c820d.crt /home/medsrv/var/openssl/certs/default.pem

echo -e "Replacing intermediate certificate ca-bundle.pem\n"
cp -va /home/medsrv/ERAD_SSL/gd_bundle-g2-g1.crt /home/medsrv/var/openssl/CA/ca-bundle.pem

echo "Backing up existing ssl.conf"
cp -va /home/medsrv/component/apache/conf.tpl/conf/ssl.conf /home/medsrv/component/apache/conf.tpl/conf/$ssl_conf_name
echo -e "Backup saved to /home/medsrv/component/apache/conf.tpl/conf/$ssl_conf_name\n"

echo "Checking the current ssl.conf"
grep "#SSLCACertificatePath @OPENSSL_CA_DIR@" /home/medsrv/component/apache/conf.tpl/conf/ssl.conf > /dev/null
if [ $? -ne 0 ]; then
        echo "Line SSLCACertificatePath @OPENSSL_CA_DIR@ needs to be modified..."
        sed -i 's?SSLCACertificatePath @OPENSSL_CA_DIR@?#SSLCACertificatePath @OPENSSL_CA_DIR@?g' /home/medsrv/component/apache/conf.tpl/conf/ssl.conf
        echo "Line entry changed to: #SSLCACertificatePath @OPENSSL_CA_DIR@"
else
        echo "Line entry arleady modified to: #SSLCACertificatePath @OPENSSL_CA_DIR@"
fi

grep "SSLCACertificateFile @OPENSSL_CA_BUNDLE@" /home/medsrv/component/apache/conf.tpl/conf/ssl.conf  > /dev/null
if [ $? -ne 1 ]; then
        echo "Line #SSLCACertificateFile @OPENSSL_CA_BUNDLE@ needs to be modified..."
        sed -i 's?#SSLCACertificateFile @OPENSSL_CA_BUNDLE@?SSLCACertificateFile /home/medsrv/var/openssl/CA/ca-bundle.pem?g' /home/medsrv/component/apache/conf.tpl/conf/ssl.conf
        echo -e "Line entry changed to: SSLCACertificateFile /home/medsrv/var/openssl/CA/ca-bundle.pem\n"
else
        echo -e "Line entry already modified to: SSLCACertificateFile /home/medsrv/var/openssl/CA/ca-bundle.pem\n"
fi

echo "Stopping Apache, Please wait..."
~/component/apache/ctrl stop
sleep 10
echo

echo "Stopping OpenSSL, Please wait..."
~/component/openssl/ctrl stop
sleep 10
echo

echo "Starting OpenSSL, Please wait..."
~/component/openssl/ctrl start
sleep 10
echo

echo "Starting Apache, Please wait..."
~/component/apache/ctrl start
sleep 10
echo

echo "Checking Apache Status, Please wait..."
~/component/apache/ctrl status
echo

echo "Verifying SSL Certificate Dates"
echo | openssl s_client -connect $HOSTNAME:443 2>/dev/null | openssl x509 -noout -dates

echo
echo "Starting cleanup"
ls /home/medsrv/ | grep "SSLcert" > /dev/null
if [ $? -ne 1 ]; then
        echo "SSLcert dir already exists, restructuring..."
        mv /home/medsrv/SSLcert /home/medsrv/SSLcert$cleanup_name 2> /dev/null
        mv /home/medsrv/ERAD_SSL /home/medsrv/SSLcert > /dev/null
        mv /home/medsrv/SSLcert.* /home/medsrv/SSLcert > /dev/null
        echo "The previous & current SSL Cert files have been consolidated into SSLcert"
else
        echo "No previous SSLcert dir found, renaming ERAD_SSL to SSLcert"
        mv ERAD_SSL SSLcert > /dev/null
        mv /home/medsrv/SSLcert.* /home/medsrv/SSLcert 2> /dev/null
fi
echo "Cleanup completed"
