#! /bin/bash
# ex: set expandtab shiftwidth=4 softtabstop=4:

#//www/uploads on /uploads
#mount -t smbfs -o username=conformis //www/uploads /uploads
#pw=confor4151

#Username:  pacs
#Password:  fg7yuf
#Server:  192.168.104.4
#Share:  uploads2

#echo "$(date)" >> /home/medsrv/work/sweep/runtimes.log

uploads=/uploads
workdir=/home/medsrv/var/archive/a1/sweep
faileddicomsend=/home/medsrv/tmp/sweepfailed
pidfile=/home/medsrv/var/run/sweep.pid

#[ -f "${pidfile}" ] && echo "$0 already running... exiting" && exit 2
[ -f "${pidfile}" ] && exit 2
trap "rm -f $pidfile; exit 13" TERM INT
trap "rm -f $pidfile; exit 0" EXIT
touch $pidfile

function isDicom() {
    f=$1

    ~/component/dcmtk/bin/dcmdump +P "0020,000d" $f > /dev/null 2>&1
    [ $? -ne 0 ] && return 1 || return 0

}

function syncUploadDir() { 
    local s=$1
    local d=$2

    [ ! -d "$d" ] && mkdir $d
    rsync -a ${s}/ ${d}/ --progress --delete
    if [ $? -ne 0 ]; then
        echo "Error syncing $s to $d"
        return 1
    else
        echo "Successfully synced $s to $d"
        return 0
    fi 
}


function findNewFiles() {
    local d=$1

    
    for f in $(find $d -type f -newer ~/work/sweep/lastrun |grep -i -v -f /home/medsrv/work/sweep/ignore); do
        if grep -w "$f" /home/medsrv/work/sweep/sentfiles >/dev/null 2>&1; then
            continue
        elif ! isDicom $f; then
            continue
        else
            echo $f
        fi
    done


    return 0
}


function debugFunction() {
    f=$1

    echo $f
    return $?
}



function sendToSelf() {
    aec=$1
    aet=$2
    ip=$3
    port=$4
    f=$5

    echo -n "Sending  $f : "
    #~/component/dicom/bin/storescu -v -d -aet $aet -aec $aec $ip $port $f
    ~/component/dicom/bin/storescu -aet $aet -aec $aec $ip $port $f
    if [ $? -ne 0 ]; then
        echo "Failed"
        return 1
    else
        echo "Success"
        echo $f >> ~/work/sweep/sentfiles
        return 0
    fi
}

function dicomSend() {
    aec=$1
    aet=$2
    ip=$3
    port=$4
    f=$5

    echo -n "Sending  $f : "
    #~/component/dicom/bin/storescu -v -d -aet $aet -aec $aec $ip $port $f
    ~/component/dicom/bin/storescu -R -aet $aet -aec $aec $ip $port $f
    if [ $? -ne 0 ]; then
        echo "Failed"
        return 1
    else
        echo "Success"
        echo $f >> ~/work/sweep/sentfiles
        return 0
    fi
}



# Main
    
cd /home/medsrv/work/sweep/
echo "$0 running at $(date)"

[ -f "${faileddicomsend}" ] && rm -f $faileddicomsend

sdate=$(date +%Y%m%d%H%M)

syncUploadDir ${uploads} ${workdir}
[ $? -ne 0 ] && echo "Error in syncUploadDir .. exiting" && exit

echo "Building list of DICOM files.."
TODO=$(findNewFiles ${workdir}/)

if [ -z "$TODO" ]; then
    echo "No new files - nothing to do"
    exit 0
else
    echo "Sending $TODO"
fi

for obj in $TODO; do
    #debugFunction $obj
    #sendToSelf CONFORMIS CONFORMISIMP 127.0.0.1 104 $obj
    dicomSend CONFORMIS CONFORMIS_DR 192.168.4.12 104 $obj
    [ $? -ne 0 ] && touch $faileddicomsend
done

[  ! -f "${faileddicomsend}" ] &&  touch -t $sdate ~/work/sweep/lastrun

