#!/bin/sh
#
# sysinfo.sh
# Script to capture linux system information
# Version 0.99
# Created by Lance Buder
#

# ** commands to execute **

# add medsrv-release file to /etc
more /home/medsrv/etc/component.ls | grep Version > /home/medsrv/etc/imagemed-release
chown medsrv:medsrv /home/medsrv/etc/imagemed-release

# ** files to dump to outfile **

FILES="
/etc/redhat-release
/etc/issue
/etc/issue.net
/proc/version
/etc/lilo.conf
/etc/modules.conf
/etc/HOSTNAME
/etc/hosts
/etc/sysconfig/network
/etc/fstab 
/etc/resolv.conf
/etc/sysconfig/static-routes
/etc/sysconfig/network-scripts/ifcfg-eth0
/etc/sysconfig/network-scripts/ifcfg-eth1
/etc/sysconfig/network-scripts/ifcfg-eth2
/etc/sysconfig/network-scripts/ifcfg-eth3 
/etc/sysconfig/network-scripts/ifcfg-lo
/etc/sysconfig/network-scripts/route-eth0
/etc/sysconfig/network-scripts/route-eth1
/etc/sysconfig/network-scripts/route-eth2
/home/medsrv/etc/imagemed-release
/home/medsrv/etc/component.ls
/home/medsrv/htdocs/download/version.txt
/home/medsrv/htdocs/main/data/welcome.html
/home/medsrv/var/conf/self.rec 
/home/medsrv/var/conf/daily.rec
/home/medsrv/var/conf/institution
/home/medsrv/var/conf/limit.rec
/home/medsrv/var/conf/limit.conf
/home/medsrv/var/conf/matching.cfg
/home/medsrv/var/conf/matching2.cfg
/home/medsrv/var/conf/localIPs.cfg
/home/medsrv/var/conf/gui.conf
/home/medsrv/var/conf/serverid.cfg
/home/medsrv/var/conf/commonnames.ls
/home/medsrv/var/conf/chmlicense.shi
/home/medsrv/var/conf/fieldNames.rec 
/home/medsrv/var/conf/lpprinter.cfg
/home/medsrv/var/conf/.ct
/home/medsrv/var/conf/system.rec
/home/medsrv/var/conf/security.rec
/home/medsrv/var/conf/taskd.rc
/home/medsrv/var/hl7/server.cfg
/home/medsrv/var/drwatson/conf/error_mail
/home/medsrv/var/drwatson/conf/ready_mail
/home/medsrv/var/disk_info
/home/medsrv/var/dicom/pb-scp.cfg
/home/medsrv/var/dicom/qr.cfg
/home/medsrv/var/prior/prior.cfg
/home/medsrv/var/prior/priorretrieve.cfg
/home/medsrv/var/arch/archive.cfg
/home/medsrv/var/dcmtk/printer.cfg
/home/medsrv/var/conf/commonnames.ls
/home/medsrv/var/openssl/ssl.key/im-site.key
/etc/cups/printers.conf
/etc/cups/lpoptions 
/etc/ntp.conf
/proc/cpuinfo
/proc/pci
/proc/cmdline
/proc/mounts
/proc/scsi/scsi
/etc/sysconfig/hwconf
/etc/sysconfig/sendmail
/etc/ssh/sshd_config"

# ** dividing line **
LINE="==================================================================="

# ** outfile file name ** 
OUTFILE=system_info.txt

# ** empty outfile **
cat /dev/null > $OUTFILE

echo "sysinfo.sh Version 0.99" >> $OUTFILE

echo "-->> System Information For: <<--" >> $OUTFILE
hostname >> $OUTFILE
hostname -i >> $OUTFILE
date >> $OUTFILE 
echo "$LINE" >> $OUTFILE
echo "** /sbin/ifconfig (Network Card Hardware Settings) **" >> $OUTFILE
ifconfig >> $OUTFILE

echo "$LINE" >> $OUTFILE
for x in $FILES
do
   echo "** $x **" >> $OUTFILE
   cat $x >> $OUTFILE
   echo "$LINE" >> $OUTFILE
done

# echo "** DICOM DEVICES TABLE **" >> $OUTFILE
# echo "select * from Target;" | ~/component/mysql/bin/mysql imagemedical >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** rpm -q -a (rpm Installed Packages) **" >> $OUTFILE
rpm -q -a >> $OUTFILE
echo "$LINE" >> $OUTFILE

echo "** RAID Controller **" >> $OUTFILE
lspci -vvv | grep -i RAID >> $OUTFILE
echo "$LINE" >> $OUTFILE
# echo "** rpm -q -i (rpm Installed Packages Detail) **" >> $OUTFILE
# rpm -q -a -i >> $OUTFILE

#echo "** chkconfig --list(list status of system services) **" >> $OUTFILE
#chkconfig --list >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** chkconfig --list | grep 3:on (what services are on) **" >> $OUTFILE
chkconfig --list | grep 3:on >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** List Modules **" >> $OUTFILE
lsmod >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** ps -axfwwww (Process List Verbose) **" >> $OUTFILE
ps -axfwwww >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** crontab -u medsrv -l (cron table for medsrv) **" >> $OUTFILE
crontab -u medsrv -l >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** crontab -u root -l (cron table for root) **" >> $OUTFILE
crontab -u root -l >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** df -h (Disk Usage) **" >> $OUTFILE
df -h >> $OUTFILE

echo "$LINE" >> $OUTFILE
echo "** free -k (Memory Usage in KBytes) **" >> $OUTFILE  
free -k >> $OUTFILE 

echo "$LINE" >> $OUTFILE
echo "** route -n **" >> $OUTFILE  
route -n  >> $OUTFILE 

echo "$LINE" >> $OUTFILE
echo "** netstat -arn **" >> $OUTFILE  
netstat -arn  >> $OUTFILE 

echo "$LINE" >> $OUTFILE
echo "** date **" >> $OUTFILE  
date  >> $OUTFILE 

echo "$LINE" >> $OUTFILE
echo "** hwclock **" >> $OUTFILE  
hwclock  >> $OUTFILE 

echo "$LINE" >> $OUTFILE
echo "** uname -a **" >> $OUTFILE  
uname -a  >> $OUTFILE 

echo "$LINE" >> $OUTFILE
echo "** dmesg **" >> $OUTFILE 
dmesg >> $OUTFILE 

echo "$LINE" >> $OUTFILE
echo "** ls -l /home/medsrv/patch/ (patchs) **" >> $OUTFILE  
ls -l /home/medsrv/patch/  >> $OUTFILE 

# echo "$LINE" >> $OUTFILE
#echo "** traceroute to demo server **" >> $OUTFILE
#traceroute 207.21.187.30 >> $OUTFILE 

echo "** printconf-tui --Xexport > settings.xml **" >> $OUTFILE 
printconf-tui --Xexport >> $OUTFILE 
echo "$LINE" >> $OUTFILE

echo "** report_templates **" >> $OUTFILE 
more /home/medsrv/data/report_template/* >> $OUTFILE 
echo "$LINE" >> $OUTFILE

echo "** report_templates **" >> $OUTFILE 
more /home/medsrv/var/dicom/mappings/* >> $OUTFILE 
echo "$LINE" >> $OUTFILE

echo "** report_templates **" >> $OUTFILE 
more /home/medsrv/var/dicom/devices/* >> $OUTFILE 
echo "$LINE" >> $OUTFILE

echo "** Device Target **" >> $OUTFILE 
echo "select * from Target;" |  /home/medsrv/component/mysql/bin/mysql imagemedical >> $OUTFILE
echo "$LINE" >> $OUTFILE

echo "** Device Service **" >> $OUTFILE 
echo "select * from DevServ;" | /home/medsrv/component/mysql/bin/mysql imagemedical >> $OUTFILE
echo "$LINE" >> $OUTFILE

echo "** DC Types **" >> $OUTFILE 
echo "select * from Dctypes;" | /home/medsrv/component/mysql/bin/mysql imagemedical >> $OUTFILE

echo "$LINE" >> $OUTFILE

# make a copy of dicom printer file local directory
#cp /home/medsrv/var/dcmtk/printer.cfg .

cp $OUTFILE /home/medsrv/etc/.

chown medsrv:medsrv /home/medsrv/etc/$OUTFILE

echo " "
echo " "
echo "--> Data Sent to $OUTFILE <--"
echo " "
echo " "

